package demo;

import static melog.skript.Denker.*;

public class Info
{
	int x, y, typ = -1, prio = -1;
	float guete;
	byte status; //0: Gedächtnis, 1: beobachtet, 2: gesagt bekommen
	
	Info(float x, float y)
	{
		this.x = xyInt(x); this.y = xyInt(y);
		status = 1;
	}
	
	Info(float x, float y, int typ, int prio)
	{
		this(x, y);
		this.typ = typ;
		this.prio = prio;
		status = 1;
	}
	
	Info(int code, boolean mem)
	{
		this.x = unwrapX(code);
		this.y = unwrapY(code);
		this.typ = read(code, typPos);
		this.prio = read(code, prioPos);
		status = (byte)(mem ? 0 : 2);
	}
	
	int code()
	{
		int code = wrap(x, y);
		code = write(code, typPos, typ);
		code = write(code, prioPos, prio);
		return code;
	}
	
	@Override public boolean equals(Object obj)
	{
		if(!(obj instanceof Info)) return false;
		Info that = (Info)obj;
		return this.x == that.x && this.y == that.y && this.typ == that.typ;
	}
	
	static final int
		BAUM = 0,
		NEBEL = 1,
		FEIND = 2,
		WEG = 3;
	
	static final byte[] typPos = {16, 17, 18, 19};
	static final byte[] prioPos = {20, 21, 22};
	//23-31 frei
	static Info dummy = new Info(0, 0, BAUM, 0);
	
	//Bitoperationen auf Integer
	static boolean get(int i, byte b) { return ((i >>> b) & 1) == 1; }
	static int set(int i, byte b) { return set(i, b, true); }
	static int unset(int i, byte b) { return set(i, b, false); }
	static int set(int i, byte b, boolean f) { return f ? (1 << b) | i : (~0 ^ (1 << b)) & i; }
	static int wrap(int x , int y) { return ((x + 128) << 8) | (y + 128); }
	static int unwrapX(int code) { int c = code & ((1 << 16) - 1); return (c >> 8) - 128; }
	static int unwrapY(int code) { int c = code & ((1 << 16) - 1); return c % (1 << 8) - 128; }
	static int read(int i, byte[] b)
	{
		int sum = 0;
		for(int p = 0; p < b.length; p++) sum += get(i, b[p]) ? 1 << p : 0;
		return sum;
	}
	public static int write(int i, byte[] b, int n)
	{
		for(int p = 0; p < b.length; p++) i = set(i, b[p], get(n, (byte)p));
		return i;
	}
}