package demo;

import melog.skript.*;
import java.util.*;
import java.util.function.*;
import static demo.Info.*;

public class Zauberformel extends Denker
{
	public Zauberformel(Ich ich, int[] erinnerung, Land land, Nachricht[] nachrichten, Freund[] freunde, Feind[] feinde, Rohstoff[] rohstoffe, Turm[] turm, Wirkung[] angriffe)
	{ super(ich, erinnerung, land, nachrichten, freunde, feinde, rohstoffe, turm, angriffe); }
	
	Stack<Info> infos = new Stack<Info>();
	
	void infoFilter(Info info)
	{
		if(info.typ == BAUM && (land.baum(info.x, info.y) || land.nebel(info.x, info.y))) infos.push(info);
	}
	
	@Override public void warnung() {}
	
	@Override public void denke() //Beginn des Denkzyklusses
	{	
		if(ich.zeit == 0) for(int i = 0; i < erinnerung.length; i++) erinnerung[i] = dummy.code();
		
		for(int erin : erinnerung) if(erin != dummy.code()) infoFilter(new Info(erin, true));
		for(Nachricht nach : nachrichten) infoFilter(new Info(nach.nachricht, false));
		
		switch(ich.typ)
		{
			case KNECHT: knecht(); break;
			
			case WAECHTER: waechter(); break;
			case KUNDSCHAFTER: break;
			case PIONIER: break;
//			
//			case EISGOLEM: break;
//			case WASSERGOLEM: break;
//			case FLUSSGIGANT: break;
//			
//			case BLITZGOLEM: break;
//			case LUFTGOLEM: break;
//			case HIMMELSGIGANT: break;
//			
//			case ERDGOLEM: break;
//			case FEUERGOLEM: break;
//			case GEBIRGSGIGANT: break;
		}
		
		infos.sort((i1, i2) -> i1.prio - i2.prio);
		int i = 0;
		for(; i < erinnerung.length && !infos.empty(); i++)
		{ 
			if(i == 0) ich.sage(infos.peek().code(), Arrays.stream(freunde).filter(f -> f.typ == KNECHT).toArray(Freund[]::new));
			erinnerung[i] = infos.pop().code();
		}
		for(; i < erinnerung.length; i++) erinnerung[i] = dummy.code();
		
	}
	
	void knecht()
	{
		if(ich.aktion != -1) return;
		if(ich.abstand(0, 0) < 1) { ich.lege(); if(meister != null) meister.macheKnecht(); }
		if(Arrays.stream(feinde).filter(f -> f.typ != KNECHT).toArray(Feind[]::new).length > 0 || wirkungen.length > 0)
		{
			findeWeg(0, 0);
			ich.status("AHH! HILFE! Ein Gegner!!1!!");
			return;
		}
		if(ich.holz >= 15)
		{
			Info i = findeWeg(0, 0);
			ich.geheZu(i.x, i.y);
			ich.status("Ich bringe Holz zurück!");
			return;
		}
        if(land.baum(ich) && ich.arbeite())
        {
            ich.stehe();
            ich.status("Ich fälle einen Baum!");
            return;
        }
        //bestimme Aktionsziel
        Info ziel = findeRessource(0.8f, f -> land.baum(f.x, f.y));
        if(ziel != dummy)
        {
            Info info = infos.peek();
            info.typ = BAUM;
            info.prio = 2;
            ich.status("Ich sehe den Baum bei (" + info.x + "/" + info.y + ")!");
        } 
        for(Info info : infos)
        if(info.typ == BAUM && info.status != 1 && (ziel == dummy || ich.abstand(ziel.x, ziel.y) + (1 - 0.8) * abstand(xyMid(info.x), xyMid(info.y)) < ziel.guete / 1.2))
        {
        	Info baumnachricht = findeWeg(info.x, info.y);
        	baumnachricht.guete = (0.2f * abstand(info.x, info.y) + baumnachricht.guete) * 1.5f;
        	if(baumnachricht != dummy && (ziel == dummy || baumnachricht.guete < ziel.guete )) 
        	{
        		ziel = baumnachricht;
        		ich.status("Ich habe von dem Baum bei (" + info.x + "/" + info.y + ") gehört!");
        	}
        }
        Info nebel = findeRessource(0.8f, f -> land.nebel(f.x, f.y));
        if(nebel != dummy)
        {
        	Info info = infos.peek();
        	info.typ = NEBEL;
        	info.prio = 0;
        	nebel.guete *= 2;
        	nebel.guete += 2;
        	if(ziel == dummy || nebel.guete < ziel.guete)
       		{
        		ziel = nebel;
        		ich.status("Ich erkunde bei (" + info.x + "/" + info.y + ")!");
       		}
        }
        if(ziel != dummy) ich.geheZu(ziel.x,ziel.y);
        else //nutzlos -> Selbstmord
        {
        	Knoten k = aStern(ich.x, ich.y, f -> true, f -> ich.abstand(f.x, f.y), f -> land.fluss(f.x, f.y) || land.meer(f.x, f.y));
           	ich.geheZu(k.x, k.y);
           	ich.status("Das Leben ist wertlos. Ich habe keinen Nutzen in dieser Welt. Auf Wiedersehen :c");
        }
        ich.geheZu(ziel.x,ziel.y);
    }
	
	void waechter()
	{
		wache();
	}
	
	void kundschafter()
	{
		erkunden();
	}
	
	void erkunden()
	{
		
		findeBerge(4, f -> land.nebel(f.x, f.y));
	}
	
	void wache()
	{
		Optional<Feind> off = Arrays.stream(feinde).filter(f -> true).max((f1, f2) -> (int) Math.signum(ich.abstand(f1) - ich.abstand(f2)));
		if(off.isPresent()) 
		{
			ich.attackiere(off.get());
			return;
		}
		if(land.niveau(ich) < 10 || !Arrays.stream(freunde).anyMatch(f -> f.typ == KNECHT) || Arrays.stream(freunde).anyMatch(f -> f.typ == WAECHTER && ich.abstand(f) < 5))
		{
			if(findeBerge(5, f -> (land.niveau(f.x, f.y) > 10 && Arrays.stream(freunde).anyMatch(ff -> ff.typ == WAECHTER && abstand(ff.x, ff.y, f.x, f.y) < 5))) != dummy)
				ich.status("Gehe auf Wachposten!");
			else
			{
				Optional<Freund> of = Arrays.stream(freunde).filter(f -> f.typ == KNECHT).max((f1, f2) -> (int) Math.signum(ich.abstand(f1) - ich.abstand(f2)));
				if(of.isPresent()) findeWeg(of.get().x, of.get().y);
				else findeWeg(0,0);
				ich.status("Bewache die Knechte!");
			}
		}
		else 
		{
			ich.stehe();
			ich.status("Bin auf Wache!");
		}
		
	}
	///////////////////////////////////////////////////////
	Info findeRessource(float ego, Predicate<Feld> ziel)
	{
		Knoten k = aStern(ich.x, ich.y, f -> feldBegehbar(f.x, f.y) && (ziel.test(f) || !land.nebel(f.x, f.y)), f -> (1 - ego) * abstand(xyMid(f.x), xyMid(f.y)), ziel);
		if(k == null) return Info.dummy;
		infos.push(new Info(k.x, k.y));
		float f = k.f;
		while(k.pre != null && !wegBegehbar(ich.x, ich.y, k.x, k.y)) k = k.pre;
		Info i = new Info(k.x, k.y);
		i.guete = f;
		i.typ = Info.WEG;
		return i;
	}
	
	Info findeBerge(float height, Predicate<Feld> ziel)
	{
		Knoten k = aStern(ich.x, ich.y, f -> feldBegehbar(f.x, f.y) && (ziel.test(f) || !land.nebel(f.x, f.y)), f -> height * (1 - land.niveau(f.x, f.y) / 17), ziel);
		if(k == null) return Info.dummy;
		infos.push(new Info(k.x, k.y));
		float f = k.f;
		while(k.pre != null && !wegBegehbar(ich.x, ich.y, k.x, k.y)) k = k.pre;
		Info i = new Info(k.x, k.y);
		i.guete = f;
		i.typ = Info.WEG;
		return i;
	}
	
	//A* mit Entwicklungspunkt = Ziel der Wegfindung
	//nur Knotenfelder, die begehbar sind, können Teil des Weges sein
	//die Knoten sollen nach dem Abstand zu ich sortiert werden, um minimalen Weg zu finden
	//gesucht wird ein Knoten, zu dem ich direkt gehen kann
	Info findeWeg(float x, float y)
	{
		Knoten k = aStern(x, y, f -> feldBegehbar(f.x, f.y), f -> ich.abstand(f.x, f.y), f -> wegBegehbar(ich.x, ich.y, f.x, f.y));
		if(k == null) return Info.dummy; //kein Weg gefunden
		Info i = new Info(k.x, k.y);
		i.guete = k.f;
		i.typ = Info.WEG;
		return i; //gibt die geschätzte Entfernung an
	}
	
	class Knoten extends Feld { float f; Knoten pre; Knoten(float x, float y) { super(x, y); } }
	
	Knoten aStern(float x0, float y0, Predicate<Feld> weg, Function<Feld, Float> heu, Predicate<Feld> ziel)
	{
		class Kasten extends Knoten
		{
			float g;
			
			Kasten(float x, float y, Kasten pre)
			{
				super(x, y);
				if(pre != null)
				{
					g = pre.g + 1;
					this.pre = pre;
				}
				f = g + heu.apply(new Feld(x, y));
			}
		}
		Set<Kasten> closed = new HashSet<Kasten>();
		PriorityQueue<Kasten> open = new PriorityQueue<Kasten>(10, new Comparator<Kasten>()
		{
			public int compare(Kasten k1, Kasten k2) { return (int)Math.ceil(k1.f - k2.f); } //vergleicht f-Werte
		});
		open.add(new Kasten(x0, y0, null));
		while(!open.isEmpty())
		{
			Kasten current = open.poll();
			if(ziel.test(current)) return current;
			closed.add(current);
			float x = current.x; float y = current.y;
			Kasten[] succs = { new Kasten(x + 1, y, current), new Kasten(x, y + 1, current), new Kasten(x - 1, y, current), new Kasten(x, y - 1, current) };
			label: for(Kasten succ : succs) if(weg.test(succ))
			{
				for(Kasten k : closed) if(k.equals(succ)) continue label;
				Kasten alt = null;
				for(Kasten k : open) if(k.equals(succ))
				{
					if(k.g > succ.g) alt = k; //kürzerer Weg gefunden
					else alt = succ;
					break;
				}
				if(alt == null) open.add(succ); //neuer Knotenpunkt
				else if(alt != succ)
				{ //Knoten aktualisieren
					open.remove(alt);
					open.add(succ);
				}
			 }
		}
		return null;
	}
	
	//prüft, ob ein Feld für den Golem begehbar ist
	boolean feldBegehbar(float x, float y)
	{ return !(land.meer(x, y) || land.mauer(x, y) || !(ich.element == WASSER || ich.istFlieger) && land.fluss(x, y)); }
	
	//prüft, ob eine Luftlinie für den Golem begehbar ist
	boolean wegBegehbar(float x1, float y1, float x2, float y2)
	{
		float rX = x2 - x1, rY = y2 - y1; //Verbindung
		float abs = (float)Math.sqrt(rX * rX + rY * rY); //Abstand
		if(abs == 0) return feldBegehbar(x1, y1); //Sonderfall
	    rX /= abs; rY /= abs; float sx = Math.signum(rX), sy = Math.signum(rY), rpx = sx * rX, rpy = sy * rY; //normierte Größen und Vorzeichen
		do
		{
		    if(!feldBegehbar(x1, y1)) return false; //nicht begehbares Feld gefunden
			float kx = (x1 + 1000000.5f) % 1, ky = (y1 + 1000000.5f) % 1; //Ort innerhalb des Kästchens
			float kpx = sx < 0 ? 1 - kx : kx, kpy = sy < 0 ? 1 - ky : ky; //Ort wird mit rp mitgespiegelt
			Stack<Float> ps = new Stack<Float>(); //Liste der Schrittlängen, die in angrenzende Felder führen
			if(rpx != 0) { float l = (1 - kpx) / rpx; if(kpx < 1) ps.push(l); ps.push(l + 1 / rpx); } //Schrittlängen ins nächste und übernächste Feld in x-Richtung
			if(rpy != 0) { float l = (1 - kpy) / rpy; if(kpy < 1) ps.push(l); ps.push(l + 1 / rpy); } //Schrittlängen ins nächste und übernächste Feld in y-Richtung
			float p1 = 0.1f, p2 = 0.1f; //die beiden kleinsten Schrittlängen
			if(ps.size() >= 2) //wenn nicht, Sonderfall
			{
				ps.sort((d1, d2) ->
				{ //ordnet die Entfernungen
					float diff = d2 - d1;
					return diff < 0 ? -1 : (diff > 0 ? 1 : 0);
				});
				p1 = ps.pop(); p2 = ps.pop();
			}
			x1 += rX * (p1 + p2) / 2; y1 += rY * (p1 + p2) / 2; //gehe in die Mitte der ersten beiden Schrittlängen
		} while((x2 - x1) * rX + (y2 - y1) * rY >= 0); //solange noch nicht das Ziel überschritten
		return true; //kein nicht begehbares Feld auf dem Weg
	}
	
	class Feld
	{
		float x, y;
		Feld(float x, float y) { this.x = x; this.y = y; }
		@Override public boolean equals(Object obj)
		{
			if(!(obj instanceof Feld)) return false;
			float dx = ((Feld)obj).x - x; float dy = ((Feld)obj).y - y;
			return dx * dx + dy * dy < 0.1;
		}
	}
	
	public static void main(String[] args)
	{
		start("laozi.Laozi", "sunzi.Sunzi");
	}
} //Ende Zauberformel